<?php

if( ! class_exists('xa_msm_shipping_signature_processor') )
{
	class xa_msm_shipping_signature_processor{
		var $settings;
		public function __construct() {
			$this->settings = get_option('xa_msm_shipping_addon_rate_role_matrix');

			add_filter( 'woocommerce_checkout_fields' , array( $this, 'xa_msm_add_checkout_field') );
			add_action( 'woocommerce_checkout_update_order_review', array($this,'xa_msm_update_checkout_field'), 1, 1 );

			add_filter( 'xa_canadapost_rate_request', array($this,'add_signature_wtih_canadapost_rate_request'), 10, 2 );
		}

		public function xa_msm_update_checkout_field( $updated_data ){
			$updated_fields = explode("&",$updated_data);
			if(is_array($updated_fields)){
				foreach($updated_fields as $updated_field){
					$updated_field_values = explode('=',$updated_field);
					if(is_array($updated_field_values)){
						if(in_array('signature_reqired',$updated_field_values)){
							$this->wf_update_signaturee_datas( urldecode($updated_field_values[1] ) );
						}
					}
				}
			}
			WC()->cart->calculate_shipping();
		}

		private function wf_update_signaturee_datas( $value='' ){
			if( WC()->version < '2.7.0' ){
				WC()->customer->__set( 'signature_reqired', $value );
			}else{
				WC()->customer->update_meta_data( 'signature_reqired', $value );
			}
		}

		private function wf_get_signature_datas( $order_details='' ){
			if( !empty( $order_details ) ){
				if( WC()->version < '2.7.0' ){
					return ( isset($order_details->signature_reqired) ) ? json_decode( $order_details->signature_reqired ) : '';
				}else{
					$address_field = $order_details->get_meta('signature_reqired');
					return ( !empty( $address_field ) ) ? json_decode($address_field) : '';
				}
			}else{
				if( WC()->version < '2.7.0' ){
					return WC()->customer->__get('signature_reqired');
				}else{
					return WC()->customer->get_meta('signature_reqired');
				}
			}
		}


		public function add_signature_wtih_canadapost_rate_request( $request, $package ){
			$xml_obj = new SimpleXMLElement($request);
			$siganature_options = array('SO','PA18','PA19', 'DNS');

			$signature_exists = false; $new_options = '';
			foreach ($xml_obj->options->option as $key => $option) {
				$new_options .= '<option>' . "\n";
				$new_options .= '	<option-code>' . $option->{'option-code'} . '</option-code>' . "\n";
				if (!empty($option->{'option-amount'}) ){
					$new_options .= '	<option-amount>' . $option->{'option-amount'} . '</option-amount>' . "\n";
				}
				$new_options .= '</option>' . "\n";

				if( in_array( (string)$option->{'option-code'}, $siganature_options) ){
					$signature_exists = true;
				}
			}

			if( $this->wf_get_signature_datas() && !$signature_exists){
				$new_options .= '<option>' . "\n";
				$new_options .= '	<option-code> SO </option-code>' . "\n";
				$new_options .= '</option>' . "\n";
			}

			unset($xml_obj->options);
			
			$doc = new DOMDocument();
			$doc->formatOutput = TRUE;
			$doc->loadXML($xml_obj->asXML());

			return str_replace( '</parcel-characteristics>', '</parcel-characteristics>'.'<options>'.$new_options.'</options>', $doc->saveXML() );
		}

		public function xa_msm_add_checkout_field($fields){
			if( empty($this->settings['rate_section_1']['signature_reqired']) ){
				return $fields;
			}
			$fields['billing']['signature_reqired'] = array(
				'label'       => __('Delivery Signature required', 'xa_msm_hide_shipping_method'),
				'required'    => false,
				'clear'       => false,
				'type'        => 'checkbox',
				'class' 	  => array ('address-field', 'update_totals_on_change' ),
			);
			return $fields;
		}


		public function debug( $message, $type = 'notice' ) {
			if ( XA_MSM_DEBUG=='on' ) {
				wc_add_notice( $message, $type );
			}
		}
	}
}
new xa_msm_shipping_signature_processor;
